import numpy as np
import time
import random
import os
import threading
obstacle = 1
chance = [1,1,1,0,0,0,0,0,0,0,0,0,0]

class myThread (threading.Thread):   #继承父类threading.Thread
    def __init__(self, threadID,cla):
        threading.Thread.__init__(self)
        self.threadID = threadID
        self.cla = cla
    def run(self):                   #把要执行的代码写到run函数里面 线程在创建后会直接运行run函数
        self.cla.change_map()

class find_road:
    def __init__(self,map1,map2,x,y):
        self.map1 =map1.copy()
        self.map2 = map2
        self.map = map1
        shape = np.shape(self.map)  # 注意x为第几行，y为第几列
        self.row = shape[1]
        self.line = shape[0]
        self.four = 0
        self.two = 0
        self.x = x - 1
        self.num = 4
        self.y = y - 1
        self.loading = []
        self.road = list()
        self.end = -1
        self.get = []

    def change_map(self):
        step = 1
        while True:
            if step == 1:
                self.map += self.map2
                step = 0
            else:
                step = 1
                self.map -= self.map2
            time.sleep(15)
            print("call")

    def get_nodes(self):
        self.nodes = [[self.x * self.row + self.y]]

    def find_next_nodes(self,node,generation):
        next_nodes = list()
        x,y = self.get_position(node)
        next_nodes.append([x-1,y])
        next_nodes.append([x+1,y])
        next_nodes.append([x,y+1])
        next_nodes.append([x,y-1])
        for i,j in next_nodes:
            n = i *self.row + j
            if self.map[i][j] != 1 and n not in self.nodes[generation - 1] \
                    and n not in self.nodes[-1]:
                if len(self.nodes) != generation+1:
                    self.nodes.append([])
                self.nodes[generation].append(n)

    def get_position(self,value):
        y = value % self.row
        x = int((value - y) / self.row)
        return x,y

    def is_find(self,target):
        find = False
        for value in self.nodes[-1]:
            x,y = self.get_position(value)
            if self.map[x][y] == target:
                self.end = x * self.row + y
                find = True
                break
        return find

    def is_road(self,this_value,end_value):
        road = False
        if abs(this_value - end_value) == 1 or \
           abs(this_value - end_value) == self.row:
            road = True
        return road


    def begin_search(self):
        self.get_four = False
        self.get_two = False
        move = True
        road2 = None
        end2 = None
        road4 = None
        end4 = None
        change = False
        self.print_to_screen()
        target = 2
        while self.num >0:
            self.get_nodes()
            gen = 1
            if target == 5 and len(self.loading)==0: #卸货
                target = 2
            if self.get_four and not change: #获得密码
                target = 2
                change = not change
            if len(self.loading) == 2 and move == True: #满货
                target = 5
            while not self.is_find(target):
                for node in self.nodes[gen-1]:
                    self.find_next_nodes(node,gen)
                gen += 1
            self.draw_road()

            if self.get.count(2) + self.loading.count(2) == 3 and move and 4 not in self.loading and 4 not in self.get:
                #2取完
                target = 4
                self.get_two = True

            elif not self.get_four and not self.get_two: #取完所有
                if target == 2: #计算2、4路径
                    target = 4
                    road2 = self.road.copy()
                    end2 = self.end
                    self.two = len(self.road)
                else:
                    target = 2
                    road4 = self.road.copy()
                    end4 = self.end
                    self.four = len(self.road)
                if move:
                    move = False
                else:
                    move = True

            if move: #移动
                if target == 5: #目标为5
                    self.move()
                elif not self.get_four and not self.get_two: #没有拿全的移动
                    if self.four>=self.two: #比对2、4路径长度
                       target = 2
                       self.road = road2
                       self.end = end2
                    else:
                        target = 4
                        self.road = road4
                        self.end = end4
                    self.move()
                else:
                    self.move()
            self.road = []




    def draw_road(self):
        gen = len(self.nodes) - 2
        end = self.end
        self.road.append(self.end)
        while gen >= 0:
            for n in self.nodes[gen]:
                if self.is_road(n,end):
                    self.road.append(n)
                    gen -= 1
                    end = n
                    break

    def move(self):
        n_x,n_y =self.get_position(self.road[-2])
        if self.map[22][22] != 5 and self.map[22][22] != 3:
            self.map[22][22] = 5

        if [n_x,n_y] == list(self.get_position(self.end)):
            if self.map[n_x][n_y] == 2:
                if chance.pop(random.randint(0,len(chance)-1)) == 1:
                    self.loading.append(2)

            if self.map[n_x][n_y] == 4:
                self.loading.append(4)
                self.get_four = True
            if self.map[n_x][n_y] == 5:
                for i in range(2):
                    self.get.append(self.loading.pop(0))
                self.num -= 2
        self.map[self.x][self.y] = 0
        self.map[n_x][n_y] = 3
        self.x = n_x
        self.y = n_y
        self.print_to_screen()
        time.sleep(0.5)

    def print_to_screen(self):
        os.system("CLS")
        print("load:", self.loading)
        print("get:",self.get)
        print(chance)
        for x in range(self.line):
            for y in range(self.row):
                if self.map[x][y] == 0:
                    print(" ",end=" ")
                if self.map[x][y] == 1:
                    print("#",end=" ")
                if self.map[x][y] == 2:
                    print("$",end=" ")
                if self.map[x][y] == 3:
                    print("&",end=" ")
                if self.map[x][y] == 4:
                    print("+",end=" ")
                if self.map[x][y] == 5:
                    print("=",end=" ")
            print("")





if __name__ == "__main__":
    map1 = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 3, 0, 0, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 2, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 2, 1, 2, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 2, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 1, 2, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 4, 1, 0, 0, 0, 1, 2, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 0, 1, 2, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 5, 0, 1],
            [1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]]
    map2 = [[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
               [0, -1, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -1, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
               [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
               [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]]

map1 = np.array(map1)
map2 = np.array(map2)

test = find_road(map1,map2,2,2)
thred = myThread(1,test)
thred.start()
test.begin_search()
