import numpy as np
import time
import serial
import matplotlib.pyplot as plt
from binascii import b2a_hex, a2b_hex
import os
import seaborn as sns
import threading


class universe:
    def __init__(self, map, mpc, start_x, start_y):
        #self.ser = ser
        self.map = np.array(map)
        self.mpc = np.array(mpc)
        self.complete = False
        self.tim = 30
        self.start_x = start_x - 1
        self.fu = False
        self.get = 0
        self.load = 0
        self.start_y = start_y - 1
        self.hang = np.shape(map)[0]
        self.lie = np.shape(map)[1]
        self.start_node = self.start_x * self.hang + self.start_y

    @staticmethod
    def get_hex(value):
        if value == 0:
            value = b"\x00"
        elif value == 1:
            value = b"\x01"
        elif value == 2:
            value = b"\x02"
        elif value == 3:
            value = b"\x03"
        elif value == 4:
            value = b"\x04"
        elif value == 5:
            value = b"\x05"
        elif value == 6:
            value = b"\x06"
        elif value == 7:
            value = b"\x07"
        elif value == 8:
            value = b"\x08"
        elif value == 9:
            value = b"\x09"
        elif value == 10:
            value = b"\x0a"
        elif value == 11:
            value = b"\x0b"
        elif value == 12:
            value = b"\x0c"
        elif value == 13:
            value = b"\x0d"
        return value

    @staticmethod
    def b2d(value):
        value = int("0x" + str(b2a_hex(value), encoding="utf-8"), 16)
        return value

    def reverse_map(self):
        sh = np.shape(self.map)
        lx = sh[0]
        ly = sh[1]
        new_map = np.zeros((lx, ly))
        for x in range(lx):
            for y in range(ly):
                new_map[x][y] = self.map[24 - x][y]
        self.map = new_map

    def set_start_point(self):
        self.start_x, self.start_y = self.get_position(self.start_node)
        self.map[self.start_x][self.start_y] = 3

    def get_value(self, x, y):
        value = x * self.lie + y
        return value

    def get_targets(self):
        target = [2, 4]
        get = []
        for x in range(self.hang):
            for y in range(self.lie):
                if self.map[x][y] in target:
                    get.append(self.get_value(x, y))
        return get

    def get_position(self, value):
        y = value % self.lie
        x = (value - y) / self.lie
        x = int(x)
        return x, y

    """
    @staticmethod
    def count_points(long_list):
        length = 0
        for each in long_list:
            length += len(each)
        print(length)
    
    def redefine_map(self):
        get_lis = self.get_targets()
        value_map = [[[] for i in range(self.lie)] for j in range(self.hang)]
        value_map = self.get_redefinde_map(value_map)
        for p in get_lis:
            lis = [[p]]
            gen = 1
            while lis[-1] != []:
                for node in lis[gen - 1]:
                    self.find_next_nodes(node, gen, lis)
                gen += 1
            lis.pop(-1)
            value_map = self.set_value(value_map,lis)
        pass#kdfdsjfsdfjisfrfvfgkfwenwenwefnjwefnjerjjjnjnj

    def set_value(self,vp,lis):
        start = lis[0][0]
        s_x, s_y = self.get_position(start)
        if self.map[s_x][s_y] == 2:
            value =100
        elif self.map[s_x][s_y] == 4:
            value = 400
        for i in range(len(lis)):
            p = value *2/ (i + 1)**2
            for n in lis[i]:
                n_x,n_y = self.get_position(n)
                vp[n_x][n_y] += p
        return vp

    def get_redefinde_map(self, vp):
        for x in range(self.hang):
            for y in range(self.lie):
                 vp[x][y] = 0
        return vp
    """

    def find_next_nodes(self, node, gen, lis):
        next_nodes = list()
        node_x, node_y = self.get_position(node)
        m = self.map
        if m[node_x + 1][node_y] != 1:
            next_nodes.append([node_x + 1, node_y])
        if m[node_x - 1][node_y] != 1:
            next_nodes.append([node_x - 1, node_y])
        if m[node_x][node_y + 1] != 1:
            next_nodes.append([node_x, node_y + 1])
        if m[node_x][node_y - 1] != 1:
            next_nodes.append([node_x, node_y - 1])
        for px, py in next_nodes:
            p_value = self.get_value(px, py)
            if len(lis) != gen + 1:
                lis.append([])
            if p_value not in lis[gen - 2] and p_value not in lis[gen - 1] and p_value not in lis[gen]:
                lis[gen].append(p_value)

    def is_road(self, this_value, end_value):
        road = False
        if abs(this_value - end_value) == 1 or \
                abs(this_value - end_value) == self.lie:
            road = True
        return road

    def is_find(self, target, lis):
        find = False
        end = -1
        for value in lis[-1]:
            x, y = self.get_position(value)
            if self.map[x][y] == target:
                end = self.get_value(x, y)
                find = True
                break
        return find, end

    def change_map(self):
        while 1:
            time.sleep(1)
            self.tim -= 1
            if self.tim == 0:
                self.map += self.mpc
                self.mpc = -self.mpc
                self.tim = 30
                print("+++++++++++++++++++change_map++++++++++++++++++++")
                print("+++++++++++++++++++change_map++++++++++++++++++++")
                print("+++++++++++++++++++change_map++++++++++++++++++++")
                print("+++++++++++++++++++change_map++++++++++++++++++++")
            self.print2screen()
            print(self.tim)



    def ser_recieve(self,msg):
        recieve = False
        b = []
        self.ser_out() # 请求
        while not recieve:
            try:
                for i in range(3):
                    bb = self.ser.read()
                    if bb:
                        b.append(bb)
            except:
                pass
            if len(b) == 3:  # 判断
                recieve = True
                s = str(b[0],encoding="utf-8")
                v1 = self.b2d(b[1])
                v2 = self.b2d(b[2])
            time.sleep(0.1)

    def ser_out(self, s, v1, v2):
        a = s.encode()
        v1 = self.get_hex(v1)
        v2 = self.get_hex(v2)
        self.ser.write(a)
        self.ser.write(v1)
        self.ser.write(v2)

    def search(self):
        self.k_block = 1
        target = 2
        self.set_start_point()
        while not self.complete:
            lis = [[self.start_node]]
            gen = 1
            find = False
            while not find:
                for node in lis[gen - 1]:
                    self.find_next_nodes(node, gen, lis)
                gen += 1
                find, end = self.is_find(target, lis)
            road = self.get_road(end, lis)
            dl = self.get_dir_lis(road)

            self.final_cube = self.get_dir(road[-2], end)
            moving = road[-2]
            dv = self.get_dis(dl, end, target)
            #print(self.final_cube)
            """
            if dv:
                mmx, mmy = self.get_position(moving)
                mmx = 24 - mmx
                mmx = int((mmx + 1) / 2)
                mmy = int((mmy + 1) / 2)
                self.ser_out("", mmx, mmy)  # 对机器人输出
            """
            if self.k_block == 4:
                target = 4
            else:
                target = 2
            if self.get == 4:
                self.complete = True
            if self.load == 2:
                target = 5


    def get_dis(self, l, end, target):
        if l:
            last = l[0]
            dis = 0
            for i in l:
                if i == last:
                    dis += 1
                else:
                    break
            dv = last, dis
            self.reset_p(dv)
            self.set_start_point()
            self.print2screen()
            return dv
        else:
            ex, ey = self.get_position(end)
            if target == 5:
                input("ok?")
                #self.ser_recieve()  # 块解码操作
                self.load = 0
                self.get += 2
                #print(self.get)
            if target == 2:
                choice = input("(y)es,(n)o,(o)ther team")
                if choice == "y":
                    #self.ser_recieve()  # 取块操作
                    self.load += 1
                    self.k_block += 1
                if choice == "o":
                    self.map[24 - ex][ey] = 4
                    self.k_block += 1
                os.system("cls")
            if target == 4:
                input("ok?")
                #self.ser_recieve()  # 取块
                self.load += 1
            if target != 5:
                self.map[ex][ey] = 0

    def reset_p(self, dv):
        dirction = dv[0]
        #distance = dv[1]
        x, y = self.get_position(self.start_node)
        if dirction == "up":
            self.start_node -= 1 * self.lie
        elif dirction == "down":
            self.start_node += 1 * self.lie
        elif dirction == "left":
            self.start_node -= 1
        elif dirction == "right":
            self.start_node += 1
        self.map[x][y] = 0

    def get_dir_lis(self, l):
        d_l = []
        for i in range(len(l) - 2):
            t = l[i]
            o = l[i + 1]
            d = self.get_dir(t, o)
            d_l.append(d)
        return d_l

    def get_dir(self, this, other):
        if this - other == -1:
            d = "right"
        elif this - other == 1:
            d = "left"
        elif this - other == -25:
            d = "down"
        elif this - other == 25:
            d = "up"
        return d

    def get_road(self, end, lis):
        road = []
        gen = len(lis) - 2
        road.append(end)
        while gen >= 0:
            for n in lis[gen]:
                if self.is_road(n, end):
                    road.append(n)
                    gen -= 1
                    end = n
                    break
        road.reverse()
        return road

    def print2screen(self):
        plt.clf()
        plt.ion()
        sns.heatmap(self.map, fmt="d", cmap='YlGnBu')
        plt.pause(0.1)
        plt.show()


if __name__ == "__main__":
    map1 = [[1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 0, 0, 0, 1, 0, 2, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 1, 2, 1, 0, 1, 2, 1, 0, 0, 0, 1],
            [1, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 2, 0, 1, 0, 1],
            [1, 2, 1, 2, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 2, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 2, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1],
            [1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1],
            [1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 0, 1, 0, 0, 0, 1, 0, 2, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 0, 1, 2, 1, 0, 1, 0, 1, 1, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1],
            [1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 1],
            [1, 2, 1, 2, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 1, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 2, 0, 1, 0, 2, 0, 1, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1],
            [1, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 2, 1, 2, 1, 0, 1, 2, 1, 0, 5, 0, 1],
            [1, 0, 0, 0, 1, 0, 2, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1],
            [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]]
    map2 = [[0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
            [0, -1, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, -1, -1, 0],
            [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0],
            [0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]]

    #ser = serial.Serial("/dev/ttyTHS2", 115200, timeout=3)
    #if not ser.open():
    #    ser.open()
    team = input("enter your team")
    if team == "red":
        k = 0
        x = 2
        y = 2
    elif team == "blue":
        k = 1
        x = 24
        y = 2
    a = universe(map1, map2, x, y)
    if k:
        a.reverse_map()
    #ser.flushInput()
    input("push any botton")
    a.change_map()
    exit()
